# coding: utf-8

"""
    CyberSource Merged Spec

    All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html

    OpenAPI spec version: 0.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from pprint import pformat
from six import iteritems
import re


class PtsV2CreateOrderPost201Response(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'submit_time_utc': 'str',
        'update_time_utc': 'str',
        'status': 'str',
        'reconciliation_id': 'str',
        'client_reference_information': 'PtsV2IncrementalAuthorizationPatch201ResponseClientReferenceInformation',
        'processor_information': 'PtsV2CreateOrderPost201ResponseProcessorInformation',
        'payment_information': 'PtsV2PaymentsOrderPost201ResponsePaymentInformation',
        'buyer_information': 'PtsV2CreateOrderPost201ResponseBuyerInformation'
    }

    attribute_map = {
        'submit_time_utc': 'submitTimeUtc',
        'update_time_utc': 'updateTimeUtc',
        'status': 'status',
        'reconciliation_id': 'reconciliationId',
        'client_reference_information': 'clientReferenceInformation',
        'processor_information': 'processorInformation',
        'payment_information': 'paymentInformation',
        'buyer_information': 'buyerInformation'
    }

    def __init__(self, submit_time_utc=None, update_time_utc=None, status=None, reconciliation_id=None, client_reference_information=None, processor_information=None, payment_information=None, buyer_information=None):
        """
        PtsV2CreateOrderPost201Response - a model defined in Swagger
        """

        self._submit_time_utc = None
        self._update_time_utc = None
        self._status = None
        self._reconciliation_id = None
        self._client_reference_information = None
        self._processor_information = None
        self._payment_information = None
        self._buyer_information = None

        if submit_time_utc is not None:
          self.submit_time_utc = submit_time_utc
        if update_time_utc is not None:
          self.update_time_utc = update_time_utc
        if status is not None:
          self.status = status
        if reconciliation_id is not None:
          self.reconciliation_id = reconciliation_id
        if client_reference_information is not None:
          self.client_reference_information = client_reference_information
        if processor_information is not None:
          self.processor_information = processor_information
        if payment_information is not None:
          self.payment_information = payment_information
        if buyer_information is not None:
          self.buyer_information = buyer_information

    @property
    def submit_time_utc(self):
        """
        Gets the submit_time_utc of this PtsV2CreateOrderPost201Response.
        Time of request in UTC. Format: `YYYY-MM-DDThh:mm:ssZ` **Example** `2016-08-11T22:47:57Z` equals August 11, 2016, at 22:47:57 (10:47:57 p.m.). The `T` separates the date and the time. The `Z` indicates UTC.  Returned by Cybersource for all services. 

        :return: The submit_time_utc of this PtsV2CreateOrderPost201Response.
        :rtype: str
        """
        return self._submit_time_utc

    @submit_time_utc.setter
    def submit_time_utc(self, submit_time_utc):
        """
        Sets the submit_time_utc of this PtsV2CreateOrderPost201Response.
        Time of request in UTC. Format: `YYYY-MM-DDThh:mm:ssZ` **Example** `2016-08-11T22:47:57Z` equals August 11, 2016, at 22:47:57 (10:47:57 p.m.). The `T` separates the date and the time. The `Z` indicates UTC.  Returned by Cybersource for all services. 

        :param submit_time_utc: The submit_time_utc of this PtsV2CreateOrderPost201Response.
        :type: str
        """

        self._submit_time_utc = submit_time_utc

    @property
    def update_time_utc(self):
        """
        Gets the update_time_utc of this PtsV2CreateOrderPost201Response.
        The date and time when the request was last updated. **Example** `2016-08-11T22:47:57Z` equals August 11, 2016, at 22:47:57 (10:47:57 p.m.). 

        :return: The update_time_utc of this PtsV2CreateOrderPost201Response.
        :rtype: str
        """
        return self._update_time_utc

    @update_time_utc.setter
    def update_time_utc(self, update_time_utc):
        """
        Sets the update_time_utc of this PtsV2CreateOrderPost201Response.
        The date and time when the request was last updated. **Example** `2016-08-11T22:47:57Z` equals August 11, 2016, at 22:47:57 (10:47:57 p.m.). 

        :param update_time_utc: The update_time_utc of this PtsV2CreateOrderPost201Response.
        :type: str
        """

        self._update_time_utc = update_time_utc

    @property
    def status(self):
        """
        Gets the status of this PtsV2CreateOrderPost201Response.
        The status of the submitted transaction. Possible values:   - CREATED   - SAVED   - APPROVED   - VOIDED   - COMPLETED   - PAYER_ACTION_REQUIRED 

        :return: The status of this PtsV2CreateOrderPost201Response.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this PtsV2CreateOrderPost201Response.
        The status of the submitted transaction. Possible values:   - CREATED   - SAVED   - APPROVED   - VOIDED   - COMPLETED   - PAYER_ACTION_REQUIRED 

        :param status: The status of this PtsV2CreateOrderPost201Response.
        :type: str
        """

        self._status = status

    @property
    def reconciliation_id(self):
        """
        Gets the reconciliation_id of this PtsV2CreateOrderPost201Response.
        Reference number for the transaction. Depending on how your Cybersource account is configured, this value could either be provided in the API request or generated by CyberSource. The actual value used in the request to the processor is provided back to you by Cybersource in the response. 

        :return: The reconciliation_id of this PtsV2CreateOrderPost201Response.
        :rtype: str
        """
        return self._reconciliation_id

    @reconciliation_id.setter
    def reconciliation_id(self, reconciliation_id):
        """
        Sets the reconciliation_id of this PtsV2CreateOrderPost201Response.
        Reference number for the transaction. Depending on how your Cybersource account is configured, this value could either be provided in the API request or generated by CyberSource. The actual value used in the request to the processor is provided back to you by Cybersource in the response. 

        :param reconciliation_id: The reconciliation_id of this PtsV2CreateOrderPost201Response.
        :type: str
        """

        self._reconciliation_id = reconciliation_id

    @property
    def client_reference_information(self):
        """
        Gets the client_reference_information of this PtsV2CreateOrderPost201Response.

        :return: The client_reference_information of this PtsV2CreateOrderPost201Response.
        :rtype: PtsV2IncrementalAuthorizationPatch201ResponseClientReferenceInformation
        """
        return self._client_reference_information

    @client_reference_information.setter
    def client_reference_information(self, client_reference_information):
        """
        Sets the client_reference_information of this PtsV2CreateOrderPost201Response.

        :param client_reference_information: The client_reference_information of this PtsV2CreateOrderPost201Response.
        :type: PtsV2IncrementalAuthorizationPatch201ResponseClientReferenceInformation
        """

        self._client_reference_information = client_reference_information

    @property
    def processor_information(self):
        """
        Gets the processor_information of this PtsV2CreateOrderPost201Response.

        :return: The processor_information of this PtsV2CreateOrderPost201Response.
        :rtype: PtsV2CreateOrderPost201ResponseProcessorInformation
        """
        return self._processor_information

    @processor_information.setter
    def processor_information(self, processor_information):
        """
        Sets the processor_information of this PtsV2CreateOrderPost201Response.

        :param processor_information: The processor_information of this PtsV2CreateOrderPost201Response.
        :type: PtsV2CreateOrderPost201ResponseProcessorInformation
        """

        self._processor_information = processor_information

    @property
    def payment_information(self):
        """
        Gets the payment_information of this PtsV2CreateOrderPost201Response.

        :return: The payment_information of this PtsV2CreateOrderPost201Response.
        :rtype: PtsV2PaymentsOrderPost201ResponsePaymentInformation
        """
        return self._payment_information

    @payment_information.setter
    def payment_information(self, payment_information):
        """
        Sets the payment_information of this PtsV2CreateOrderPost201Response.

        :param payment_information: The payment_information of this PtsV2CreateOrderPost201Response.
        :type: PtsV2PaymentsOrderPost201ResponsePaymentInformation
        """

        self._payment_information = payment_information

    @property
    def buyer_information(self):
        """
        Gets the buyer_information of this PtsV2CreateOrderPost201Response.

        :return: The buyer_information of this PtsV2CreateOrderPost201Response.
        :rtype: PtsV2CreateOrderPost201ResponseBuyerInformation
        """
        return self._buyer_information

    @buyer_information.setter
    def buyer_information(self, buyer_information):
        """
        Sets the buyer_information of this PtsV2CreateOrderPost201Response.

        :param buyer_information: The buyer_information of this PtsV2CreateOrderPost201Response.
        :type: PtsV2CreateOrderPost201ResponseBuyerInformation
        """

        self._buyer_information = buyer_information

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, PtsV2CreateOrderPost201Response):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
