# coding: utf-8

"""
    CyberSource Merged Spec

    All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html

    OpenAPI spec version: 0.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from pprint import pformat
from six import iteritems
import re


class Ptsv1pushfundstransferOrderInformationAmountDetails(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'total_amount': 'str',
        'currency': 'str',
        'source_currency': 'str',
        'destination_currency': 'str',
        'surcharge': 'Ptsv2paymentsOrderInformationAmountDetailsOctsurcharge'
    }

    attribute_map = {
        'total_amount': 'totalAmount',
        'currency': 'currency',
        'source_currency': 'sourceCurrency',
        'destination_currency': 'destinationCurrency',
        'surcharge': 'surcharge'
    }

    def __init__(self, total_amount=None, currency=None, source_currency=None, destination_currency=None, surcharge=None):
        """
        Ptsv1pushfundstransferOrderInformationAmountDetails - a model defined in Swagger
        """

        self._total_amount = None
        self._currency = None
        self._source_currency = None
        self._destination_currency = None
        self._surcharge = None

        self.total_amount = total_amount
        self.currency = currency
        if source_currency is not None:
          self.source_currency = source_currency
        if destination_currency is not None:
          self.destination_currency = destination_currency
        if surcharge is not None:
          self.surcharge = surcharge

    @property
    def total_amount(self):
        """
        Gets the total_amount of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        Grand total for the order. This value cannot be negative. You can include a decimal point (.), but no other special characters. CyberSource truncates the amount to the correct number of decimal places. 

        :return: The total_amount of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        :rtype: str
        """
        return self._total_amount

    @total_amount.setter
    def total_amount(self, total_amount):
        """
        Sets the total_amount of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        Grand total for the order. This value cannot be negative. You can include a decimal point (.), but no other special characters. CyberSource truncates the amount to the correct number of decimal places. 

        :param total_amount: The total_amount of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        :type: str
        """

        self._total_amount = total_amount

    @property
    def currency(self):
        """
        Gets the currency of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        Use a 3-character alpha currency code for currency of the funds transfer.  ISO standard currencies: http://apps.cybersource.com/library/documentation/sbc/quickref/currencies.pdf  Currency must be supported by the processor. 

        :return: The currency of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        :rtype: str
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """
        Sets the currency of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        Use a 3-character alpha currency code for currency of the funds transfer.  ISO standard currencies: http://apps.cybersource.com/library/documentation/sbc/quickref/currencies.pdf  Currency must be supported by the processor. 

        :param currency: The currency of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        :type: str
        """

        self._currency = currency

    @property
    def source_currency(self):
        """
        Gets the source_currency of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        Use a 3-character alpha currency code for source currency of the funds transfer. Supported for card and bank account based cross border funds transfers.  ISO standard currencies: http://apps.cybersource.com/library/documentation/sbc/quickref/currencies.pdf 

        :return: The source_currency of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        :rtype: str
        """
        return self._source_currency

    @source_currency.setter
    def source_currency(self, source_currency):
        """
        Sets the source_currency of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        Use a 3-character alpha currency code for source currency of the funds transfer. Supported for card and bank account based cross border funds transfers.  ISO standard currencies: http://apps.cybersource.com/library/documentation/sbc/quickref/currencies.pdf 

        :param source_currency: The source_currency of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        :type: str
        """

        self._source_currency = source_currency

    @property
    def destination_currency(self):
        """
        Gets the destination_currency of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        Use a 3-character alpha currency code for destination currency of the funds transfer. Supported for card and bank account based cross border funds transfers.  ISO standard currencies: http://apps.cybersource.com/library/documentation/sbc/quickref/currencies.pdf 

        :return: The destination_currency of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        :rtype: str
        """
        return self._destination_currency

    @destination_currency.setter
    def destination_currency(self, destination_currency):
        """
        Sets the destination_currency of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        Use a 3-character alpha currency code for destination currency of the funds transfer. Supported for card and bank account based cross border funds transfers.  ISO standard currencies: http://apps.cybersource.com/library/documentation/sbc/quickref/currencies.pdf 

        :param destination_currency: The destination_currency of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        :type: str
        """

        self._destination_currency = destination_currency

    @property
    def surcharge(self):
        """
        Gets the surcharge of this Ptsv1pushfundstransferOrderInformationAmountDetails.

        :return: The surcharge of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        :rtype: Ptsv2paymentsOrderInformationAmountDetailsOctsurcharge
        """
        return self._surcharge

    @surcharge.setter
    def surcharge(self, surcharge):
        """
        Sets the surcharge of this Ptsv1pushfundstransferOrderInformationAmountDetails.

        :param surcharge: The surcharge of this Ptsv1pushfundstransferOrderInformationAmountDetails.
        :type: Ptsv2paymentsOrderInformationAmountDetailsOctsurcharge
        """

        self._surcharge = surcharge

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Ptsv1pushfundstransferOrderInformationAmountDetails):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
